//+------------------------------------------------------------------+
//|                                                  HandChannel.mq4 |
//|                                           |
//|                                                                  |
//|  2.                                                        |
//|                                                                  |
//|     :           |
//|   . :   -   ,     |
//|   - .    -       |
//| .       ,   |
//|    .     . |
//|                                                                  |
//| :                                                       |
//| ExtTimeLeft       =                                |
//| ExtTimeMiddle     =                              |
//| ExtTimeRight      =                               |
//| ExtColor          =                                    |
//| ExtGetFromFile    =                    |
//| ExtRegetFromFile  =                |
//| ExtDrawPoints     =                         |
//| ExtDrawMiddleLine =                    |
//| ExtDeleteObject   =          |
//|                                                                  |
//|         .         |
//|         .        |
//|                                                                  |
//|     : YYYY.MM.DD HH:MM                       |
//| : 2006.08.12 12:00                                       |
//|                                                                  |
//|   :                                                  |
//|      , :        |
//| USDJPY.TXT, EURUSD.TXT.  .TXT .             |
//|     \Experts\Files.                 |
//|      :                  |
//|  1             -   (  )   |
//| 2006.08.12 12:00    -                              |
//| 2006.08.13 16:00    -                            |
//| 2006.08.14 08:00    -                             |
//| Blue                -                                  |
//|             |
//|                                                           |
//|   :                                  |
//| Black, Green, Purple, Maroon, Brown, Orange, Gold, Yellow, Lime, |
//| Aqua, Blue, Magenta, Red, Gray, Silver, Pink, Beige, White.      |
//|                                                                  |
//|                 |
//|   .                                             |
//|                                                                  |
//|  ExtRegetFromFile   ,     |
//|     .        |
//|              |
//|   True,           |
//| False.       True   |
//|    . :-) (      |
//|   ).           |
//|      .               |
//|                                                                  |
//|   2:                                              |
//|   ,     .                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Karakurt"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Yellow

extern datetime ExtTimeLeft       = D'2006.08.01 00:00';
extern datetime ExtTimeMiddle     = D'2006.08.01 00:00';
extern datetime ExtTimeRight      = D'2006.08.01 00:00';
extern color    ExtColor          = Lime;
extern bool     ExtGetFromFile    = True;
extern bool     ExtRegetFromFile  = False;
extern bool     ExtDrawPoints     = False;
extern bool     ExtDrawMiddleLine = False;
extern bool     ExtDeleteObject   = False;

double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  SetIndexStyle(  0, DRAW_ARROW, EMPTY, 1, indicator_color1 );
  SetIndexArrow(  0, 251 );
  SetIndexBuffer( 0, ExtMapBuffer1 );
  SetIndexEmptyValue( 0, 0.0 );

  return ( 0 );
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int deinit()
{
  if ( ExtDeleteObject )
    DelObj();
  
  return ( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  static bool bGettingFromFile = False;
  
  string sFileName;
  string sIdentChannel; //   -   -     
  int    iFileHandle;
  int    i;
  
  if ( ExtGetFromFile ) { //    
    
    if ( ExtRegetFromFile ) //   
      DelObj(); //     
      
    else { //    
      if ( bGettingFromFile  ) //    
        return ( 0 );
      
    } //    
    
    sFileName   = Symbol() + ".txt";
    iFileHandle = FileOpen( sFileName, FILE_READ );
    
    if ( iFileHandle < 1 ) {
      Print( "   " + sFileName + " ", GetLastError() );
      return ( -1 );
    } // if
    
    for ( i = 1; i < 10; i++ ) {
    
      if ( FileIsEnding( iFileHandle ) ) {
        Print( " " );
        break;
      } // if
      
      //===    
      sIdentChannel = FileReadString( iFileHandle );
      ExtTimeLeft   = StrToTime(  FileReadString( iFileHandle ) );
      ExtTimeMiddle = StrToTime(  FileReadString( iFileHandle ) );
      ExtTimeRight  = StrToTime(  FileReadString( iFileHandle ) );
      ExtColor      = StrToColor( FileReadString( iFileHandle ) );
      
      Print( sIdentChannel );
      /*Print( "ExtTimeLeft= ", TimeToStr( ExtTimeLeft, TIME_DATE|TIME_MINUTES ) );
      Print( "ExtTimeMiddle= ", TimeToStr( ExtTimeMiddle, TIME_DATE|TIME_MINUTES ) );
      Print( "ExtTimeRight= ", TimeToStr( ExtTimeRight, TIME_DATE|TIME_MINUTES ) );*/
      Print( " ", i, "- " );
      
      DrawLines(); //   
      
    } // for
    
    Print( " : ", i-1 );
    
    bGettingFromFile = True;
    
    FileClose( iFileHandle );
  } // if (    
  
  else { //    
    DrawLines(); //    
  } // else
  
  return ( 0 );
} // int start()
  
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int DrawLines()
{
  int    iNumBarLeft;     //    
  int    iNumBarMiddle;   //   
  int    iNumBarRight;    //   
  double dPriceLeft;      //   
  double dPriceMiddle;    //   
  double dPriceRight;     //   
  double dDrawPriceRight; //    
  double dDrawPriceLeft;  //      3- 
  double dPriceDelta;     //         
  string sNameObject;
  
  //===   
  iNumBarLeft   = iBarShift( NULL, 0, ExtTimeLeft  , True );
  iNumBarMiddle = iBarShift( NULL, 0, ExtTimeMiddle, True );
  iNumBarRight  = iBarShift( NULL, 0, ExtTimeRight , True );
  
  if ( iNumBarLeft   < 0 ) { Print( "   "  , ExtTimeLeft   ); return ( -1 ); }
  if ( iNumBarMiddle < 0 ) { Print( "   ", ExtTimeMiddle ); return ( -1 ); }
  if ( iNumBarRight  < 0 ) { Print( "   " , ExtTimeRight  ); return ( -1 ); }
  
  if ( High[ iNumBarLeft  ] > Low[ iNumBarMiddle ] &&
       High[ iNumBarRight ] > Low[ iNumBarMiddle ] ) { //   
    dPriceLeft   = High[ iNumBarLeft   ];
    dPriceMiddle = Low[  iNumBarMiddle ];
    dPriceRight  = High[ iNumBarRight  ];
  } // if (   
  
  if ( Low[ iNumBarLeft  ] < High[ iNumBarMiddle ] &&
       Low[ iNumBarRight ] < High[ iNumBarMiddle ] ) { //   
    dPriceLeft   = Low[  iNumBarLeft   ];
    dPriceMiddle = High[ iNumBarMiddle ];
    dPriceRight  = Low[  iNumBarRight  ];
  } // if (   
  
  if ( ExtDrawPoints ) { //   
    if ( dPriceLeft > dPriceMiddle ) { //   
      ExtMapBuffer1[ iNumBarLeft   ] = dPriceLeft   + 5 * Point;
      ExtMapBuffer1[ iNumBarMiddle ] = dPriceMiddle - 5 * Point;
      ExtMapBuffer1[ iNumBarRight  ] = dPriceRight  + 5 * Point;
    } //   
    
    else { //   
      ExtMapBuffer1[ iNumBarLeft   ] = dPriceLeft   - 5 * Point;
      ExtMapBuffer1[ iNumBarMiddle ] = dPriceMiddle + 5 * Point;
      ExtMapBuffer1[ iNumBarRight  ] = dPriceRight  - 5 * Point;
    } //   
    
  } // if (   
  
  //===   (  ,   )
  dPriceDelta = ( dPriceLeft - dPriceRight ) / ( iNumBarLeft - iNumBarRight );
  
  //           3- 
  dDrawPriceRight = dPriceMiddle - dPriceDelta * ( iNumBarMiddle - iNumBarRight  );
  dDrawPriceLeft  = dPriceMiddle + dPriceDelta * ( iNumBarLeft   - iNumBarMiddle );
  
  //===   
  //     
  sNameObject = "BaseLine" + ExtTimeLeft;
  ObjectCreate( sNameObject, OBJ_TREND, 0,
                ExtTimeLeft , dPriceLeft,
                ExtTimeRight, dPriceRight );
  ObjectSet(    sNameObject, OBJPROP_COLOR, ExtColor );
  ObjectSet(    sNameObject, OBJPROP_WIDTH, 0 );
  ObjectSet(    sNameObject, OBJPROP_STYLE, STYLE_DASH );
  
  //      3- 
  sNameObject = "Line3" + ExtTimeLeft;
  ObjectCreate( sNameObject, OBJ_TREND, 0,
                ExtTimeLeft , dDrawPriceLeft,
                ExtTimeRight, dDrawPriceRight );
  ObjectSet(    sNameObject, OBJPROP_COLOR, ExtColor );
  ObjectSet(    sNameObject, OBJPROP_WIDTH, 0 );
  ObjectSet(    sNameObject, OBJPROP_STYLE, STYLE_DASH );
  
  //     
  if ( ExtDrawMiddleLine ) {
    sNameObject = "MidLine" + ExtTimeLeft;
    ObjectCreate( sNameObject, OBJ_TREND, 0, 
                  ExtTimeLeft , ( dPriceLeft  + dDrawPriceLeft  )/2,
                  ExtTimeRight, ( dPriceRight + dDrawPriceRight )/2 );
    ObjectSet(    sNameObject, OBJPROP_COLOR, ExtColor );
    ObjectSet(    sNameObject, OBJPROP_WIDTH, 0 );
    ObjectSet(    sNameObject, OBJPROP_STYLE, STYLE_DASHDOTDOT );
  }
  
  return ( 0 );
} // int DrawLines()

//+------------------------------------------------------------------+
//|  .
//+------------------------------------------------------------------+
void DelObj()
{
  string sNameObject;
  int    iiObject;
  
  for ( iiObject = ObjectsTotal(); iiObject >= 0; iiObject-- ) {
    sNameObject = ObjectName( iiObject );
    if ( StringFind( sNameObject, "BaseLine" ) > -1 ) ObjectDelete ( sNameObject );
    if ( StringFind( sNameObject, "Line3"    ) > -1 ) ObjectDelete ( sNameObject );
    if ( StringFind( sNameObject, "MidLine"  ) > -1 ) ObjectDelete ( sNameObject );
  } // for
  
} // void DelObj()

//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
color StrToColor( string sColor )
{
  if      ( sColor == "Black"   ) return ( Black   );
  else if ( sColor == "Green"   ) return ( Green   );
  else if ( sColor == "Purple"  ) return ( Purple  );
  else if ( sColor == "Maroon"  ) return ( Maroon  );
  else if ( sColor == "Brown"   ) return ( Brown   );
  else if ( sColor == "Orange"  ) return ( Orange  );
  else if ( sColor == "Gold"    ) return ( Gold    );
  else if ( sColor == "Yellow"  ) return ( Yellow  );
  else if ( sColor == "Lime"    ) return ( Lime    );
  else if ( sColor == "Aqua"    ) return ( Aqua    );
  else if ( sColor == "Blue"    ) return ( Blue    );
  else if ( sColor == "Magenta" ) return ( Magenta );
  else if ( sColor == "Red"     ) return ( Red     );
  else if ( sColor == "Gray"    ) return ( Gray    );
  else if ( sColor == "Silver"  ) return ( Silver  );
  else if ( sColor == "Pink"    ) return ( Pink    );
  else if ( sColor == "Beige"   ) return ( Beige   );
  else if ( sColor == "White"   ) return ( White   );
  else 
    return ( Lime );
    
} // color StrToColor()

