//+------------------------------------------------------------------+
//|                                               WeekEndChennel.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Aqua
#property indicator_color6 Aqua

extern int LastBarsCount=2;
extern int MinChanWidth=100;
extern bool gap=true;
extern bool Show_Targets=true;

//---- buffers
double ChHighBuffer[];
double ChLowBuffer[];
double Ch1xHighBuffer[];
double Ch1xLowBuffer[];
double Ch2xHighBuffer[];
double Ch2xLowBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ChHighBuffer);
   SetIndexLabel(0,"BO top");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ChLowBuffer);
   SetIndexLabel(1,"BO bottom");
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Ch1xHighBuffer);
   SetIndexLabel(2,"1xBO top");
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Ch1xLowBuffer);
   SetIndexLabel(3,"1xBO bottom");
   
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Ch2xHighBuffer);
   SetIndexLabel(4,"2xBO top");
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,Ch2xLowBuffer);
   SetIndexLabel(5,"2xBO bottom");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int barshift, correction = 0, TF = Period();
   double H,L,dif;
   
   int i = 0; double RAvg4 = 0, RAvg12 = 0;
      
   for(i=1;i<=4;i++)
      RAvg4    =    RAvg4  +  (iHigh(NULL,PERIOD_W1,i)-iLow(NULL,PERIOD_W1,i))/Point;
   for(i=5;i<=16;i++)
      RAvg12    =    RAvg12  +  (iHigh(NULL,PERIOD_W1,i)-iLow(NULL,PERIOD_W1,i))/Point;
   
   RAvg4 = RAvg4/4;
   RAvg12 = RAvg12/12;

   
//----
   if (counted_bars>0) 
      counted_bars--;
  
   int limit=Bars-counted_bars;
   
   TF = TF/60;
   if(TF == 1 && gap == true)
      correction = 1;   //H1 TF takes the last hour of last day and the first hour of this day

   for(i=0;i<limit;i++)
   {
      barshift=(TimeDayOfWeek(Time[i])-1)*24/TF+MathFloor(TimeHour(Time[i])/TF)+1;
      H=High[iHighest(NULL,0,MODE_HIGH,LastBarsCount,i+barshift-correction)];
      L=Low[iLowest(NULL,0,MODE_LOW,LastBarsCount,i+barshift-correction)];
      dif=(Point*MinChanWidth)-(H-L);
      if (dif<0) 
         dif=0;
      
      ChHighBuffer[i]=H+dif/2;
      ChLowBuffer[i]=L-dif/2;
   
      if (Show_Targets==true)
      {
         Ch1xHighBuffer[i]=ChHighBuffer[i]+(ChHighBuffer[i]-ChLowBuffer[i]);
         Ch1xLowBuffer[i]=ChLowBuffer[i]-(ChHighBuffer[i]-ChLowBuffer[i]);
         Ch2xHighBuffer[i]=ChHighBuffer[i]+2*(ChHighBuffer[i]-ChLowBuffer[i]);
         Ch2xLowBuffer[i]=ChLowBuffer[i]-2*(ChHighBuffer[i]-ChLowBuffer[i]);
      }
      Comment("Top = ",ChHighBuffer[i],"    Bottom = ",ChLowBuffer[i],"    Channel Width = ",(ChHighBuffer[i]-ChLowBuffer[i])/Point,"\nPrice From Top = ",DoubleToStr(ChHighBuffer[i]-Bid, Digits),"Price From Bottom = ",DoubleToStr(Bid-ChLowBuffer[i], Digits),"\nAverage Range 4 Weeks = ",DoubleToStr(RAvg4,2),"    Average Range Previous 12 Weeks = ",DoubleToStr(RAvg12,2));
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+